#ifndef CORR_H
#define CORR_H

#include <fstream>
#include "System.h"

using namespace std;

class Corr {
   friend class Polymers;
   friend class Polymer;
   private:
   System * sys;
   vect_f * InitCoords;
   int argc;
   const char ** argv;
   long NumCalls;
   long NumGCalls;
   int TotNumGridPoints;
   int NumWallGridPoints;
   int NumMiddleGridPoints;
   int NumGTot;
   int   GArrayIndex;
   int GArraySize;
   int * NumGMeasurements;
   int * GTimeArray;
   int * HistLayer;
   int * HistMiddle;
   double LayerSize;
   double f_end_sum;
   double f_end_var;
   double InvLayerSep;
   double InvMiddleSep;
   double RgSq, REndSq, z_ave, var;
   double * G_t;
   double * DeltaG_t;
   ofstream ofDensity;
   ofstream ofStats;
   public:
   Corr(System * sys, int NumWallGridPoints, double MiddleSep, double LayerSize);
   Corr(System * sys, int NumGTot);
   void printHeader(ofstream & of);
   void setHeaderArgs(int const argc, char const ** argv);
   void setStreams(const char * density,const  char * stats);
   void setStreams(const char * dirname, const char * density,const  char * stats);
   void MakeHistGrids();
   void recordDensity(vect_f & r);
   void update();
   void updateForce();
   void updateRg();
   void updateDensity();
   void printHists();
   void printHists(ofstream & of);
   void printStats(ofstream & of);
   void printStats();
   void printStatsCout();
   void addPointToHist(int * hist, double pos, double norm);
   void ofClose();
   void setInitCoords(vect_f * coords);
   void updateRiRiT();


};

#endif//CORR_H
