
import scipy 
import scipy.integrate
from pylab import *

ArrowsOn = False

def flow(u,v):
   h = 13.0*u*v/(1+u*(1+0.05*u))
   x =  (a-u) -h
   y = c*(b-v)-h
   #norm = sqrt(x*x+y*y)
   #return (x/norm,y/sqrt(norm))
   return (x,y)

def dx_dt(r,t=0):
    (x[0],x[1]) = flow(r[0],r[1])
    return x

a=150
b = 100
c=1.5

x = zeros((2))
t_tot = 2000.0
dt = 0.01
t = arange(0,t_tot,dt)
nx = 20
ny = 20
gapx = 2
gapy = 1

dims = (nx,ny)

fx = zeros(dims)
fy = zeros(dims)
u_init = 100.0

if ArrowsOn:
    for i in range(0,nx):
        for j in range(0,ny):
            x = gapx*i
            y = gapy*j
            (fx[i,j], fy[i,j]) = flow(x+10*gapx,y+20*gapy)

    quiver(fx,fy,pivot='mid')


else:
    x_final = []
    for v_init in arange(5,200,5.0):
        x0 = array([u_init,v_init])
        x_out, infohash = scipy.integrate.odeint(dx_dt, x0, t, full_output=True)
        plot(x_out[:,0],x_out[:,1])
        x_final.append(x_out[-1,:])
        

show()
