
import numpy
from scipy import *
from pylab import *
import time
from scipy import weave
from scipy.weave import converters



n=64
seed(1000)

s = ones((n),dtype=int)#what Nelson calls sigma's, +1 for helix state -1 for coil state
                       #helix means residue i and i+4 are hydrogen bonded. 
r = random((n))#generates a bunch of random numbers at once 
for x in range(n):#this initializes the s's to be randomly +/- 1
        if r[x] < 0.5:
            s[x] = -1

T = 5.5#Temperature
beta = 1.0/T
h = -1.0#bias for forming helix, Nelson calls this alpha, this is the field in the 1d Ising model
J=1#Cooperativity parameter, Nelson calls gamma, this is the nearest neighbor spin coupling in the 1d Ising model


#This does a monte carlo simulation of this model, which is equivalent to the 1d Ising model. It is done in C
#rather then python for efficiency. You can do this using "weave". If works on ubuntu 10.04 using python 2.6.5
#You shouldn't need to touch this C code:
def iterate(s,beta):
   r = random((n))

   code = """
       #line 26 "helixcoil.py"
       int x,y;
       int mod = n-1;
       for(x=0; x < n; x++) {
	  float field;
	  if (x < 1)
	     field = h + J*s(1);
	  else if (x > n-2)
	     field = h + J*s(n-2);
	  else
	     field = h +J*(s(x+1) + s(x-1));
	  float delta_e = s(x)*field;
	  if (exp(-beta*delta_e) > r(x)) {
	     s(x) = -s(x);
	  }
       }
           """
   weave.inline(code, ['h', 'J', 's', 'r', 'beta', 'n'], type_converters=converters.blitz, compiler = 'gcc')
   return

#Run it for a bit to equilibrate:
for k in range(100*n):
    iterate(s,beta)

       
SumM = 0#Sum of all the s's
NumAve = 0;#number of averages taken
colormap = cm.gist_gray

ion()
axis('off')
for k in range(500000):
    iterate(s,beta)
    if (k%n == 0):
        SumM += sum(s)
        NumAve += 1
    if (k%10000 == 0):
        pause(0.001)
        print "Ave M = ",SumM*(1.0/(n*NumAve)), "Number of Averages taken = ", NumAve

        s = reshape(s,(1,n))
        imshow(s,interpolation="nearest",cmap=colormap, vmin=-1,vmax=1)
	draw()
        s = reshape(s,(n))



